-----------------------
-------VARIABLES-------
-----------------------


local ADDON_NAME, namespace = ...;
local variables = {};
local functions = {};

namespace.variables = variables;
namespace.functions = functions;

local loadFrame = CreateFrame("FRAME");


-----------------------
-----EVENT HANDLING----
-----------------------


--Initial check to see if addon variables exist, if they don't, create them.
loadFrame:RegisterEvent("ADDON_LOADED");
loadFrame:RegisterEvent("PLAYER_LOGOUT"); 

loadFrame:SetScript("OnEvent", 
	function(self, event, addonName, ...)
		if event == "ADDON_LOADED" and addonName == "LPT Loot Roll" then
			if llrSettings == nil then 
				llrSettings = {};
			end
			
			--UI positions
			if llrSettings.raidLeadWindowPos == nil then
				llrSettings.raidLeadWindowPos = {["point"] = "CENTER", ["relativePoint"] = "CENTER", ["xOfs"] = 0, ["yOfs"] = 0};
			end
			
			if llrSettings.userWindowPos == nil then
				llrSettings.userWindowPos = {["point"] = "CENTER", ["relativePoint"] = "CENTER", ["xOfs"] = 0, ["yOfs"] = 0};
			end
			
			if llrSettings.itemListWindowPos == nil then
				llrSettings.itemListWindowPos = {["point"] = "CENTER", ["relativePoint"] = "CENTER", ["xOfs"] = 0, ["yOfs"] = 0};
			end
			
			--Booleans
			if llrSettings.leadMode == nil then
				llrSettings.leadMode = false;
			end
			
			if llrSettings.scrollMode == nil then
				llrSettings.scrollMode = false;
			end
			
			if llrSettings.saveMode == nil then
				llrSettings.saveMode = false;
			end
			
			if llrSettings.eventMode == nil then
				llrSettings.eventMode = false;
			end
			
			if llrSettings.assistMode == nil then
				llrSettings.assistMode = false;
			end

			if llrSettings.lootListener == nil then 
				llrSettings.lootListener = false;
			end
			
			if llrSettings.whisperListener == nil then
				llrSettings.whisperListener = false;
			end
			
			--Integers
			if llrSettings.mainRoll == nil then
				llrSettings.mainRoll = 100;
			end
			
			if llrSettings.offRoll == nil then
				llrSettings.offRoll = 50;
			end
			
			if llrSettings.mogRoll == nil then
				llrSettings.mogRoll = 25;
			end
			
			if llrSettings.historyLength == nil then
				llrSettings.historyLength = 20;
			end
			
			if llrSettings.leaderScale == nil then
				llrSettings.leaderScale = 1;
			end
			
			if llrSettings.userScale == nil then
				llrSettings.userScale = 1;
			end
			
			if llrSettings.itemListScale == nil then
				llrSettings.itemListScale = 1;
			end
			
			--History database control.
			if rollHistoryDB == nil then 
				rollHistoryDB = {};
			end
			
			if rollHistoryDB.rollHistory == nil then
				rollHistoryDB.rollHistory = {};
			end
			
			--Save mode binding.
			if llrSettings.saveMode then
				variables.rollHistory = rollHistoryDB.rollHistory;
				
				--Pre cache history items.
				for i, v in ipairs(variables.rollHistory) do
					GetItemInfo(v.item);
				end
			end
			
			variables.screenScale = functions.calculateScale();
			variables.maxRollValue = 10000;
			variables.addonLoaded = true;

			--Run startup functions.
			functions.toggleLootListener();
			functions.updateConfigWindow();
			functions.toggleWhisperListener();
			functions.controlRollListener();

			--Window positions.
			LPTLootRoll_Leader:SetPoint(llrSettings.raidLeadWindowPos.point, nil, llrSettings.raidLeadWindowPos.relativePoint, llrSettings.raidLeadWindowPos.xOfs, llrSettings.raidLeadWindowPos.yOfs);
			LPTLootRoll_User:SetPoint(llrSettings.userWindowPos.point, nil, llrSettings.userWindowPos.relativePoint, llrSettings.userWindowPos.xOfs, llrSettings.userWindowPos.yOfs);
			LPTLootRoll_ItemList:SetPoint(llrSettings.itemListWindowPos.point, nil, llrSettings.itemListWindowPos.relativePoint, llrSettings.itemListWindowPos.xOfs, llrSettings.itemListWindowPos.yOfs);

			loadFrame:UnregisterEvent("ADDON_LOADED");
		elseif event == "PLAYER_LOGOUT" then
			llrSettings.raidLeadWindowPos.point, _, llrSettings.raidLeadWindowPos.relativePoint, llrSettings.raidLeadWindowPos.xOfs, llrSettings.raidLeadWindowPos.yOfs = LPTLootRoll_Leader:GetPoint();
			llrSettings.userWindowPos.point, _, llrSettings.userWindowPos.relativePoint, llrSettings.userWindowPos.xOfs, llrSettings.userWindowPos.yOfs = LPTLootRoll_User:GetPoint();
			llrSettings.itemListWindowPos.point, _, llrSettings.itemListWindowPos.relativePoint, llrSettings.itemListWindowPos.xOfs, llrSettings.itemListWindowPos.yOfs = LPTLootRoll_ItemList:GetPoint();
		end
	end
);